Subject: bug#75328: closed (Re: bug#75328: 31.0.50; use-package cannot override a built in package)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 11 Jan 2025 11:00:02 +0000

Your bug report

#75328: 31.0.50; use-package cannot override a built in package

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
75328: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=75328
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#75328: 31.0.50; use-package cannot override a built in package
From: Eli Zaretskii <[email-masked]>
To: Philip Kaludercic <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Sat, 11 Jan 2025 12:59:08 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Philip Kaludercic <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Sun, 05 Jan 2025 20:33:18 +0000
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >> From: Philip Kaludercic <[email-masked]>
> >> Cc: "Mark A. Hershberger" <[email-masked]>,  [email-masked]
> >> Date: Sat, 04 Jan 2025 21:57:18 +0000
> >> 
> >> Eli Zaretskii <[email-masked]> writes:
> >> 
> >> >> The following does not check out the transient repository into
> >> >> ~/.emacs.d/elpa/:
> >> >> 
> >> >>     rm -rf ~/.emacs.d &&
> >> >>     echo '(setq package-install-upgrade-built-in t)
> >> >>     (use-package transient :vc (:url "https://github.com/magit/transient" :rev :newest) :ensure t)' > ~/.emacs &&
> >> >>     ~/bin/emacs
> >> >
> >> > Philip, shouldn't package-install-upgrade-built-in allow upgrading a
> >> > built-in package via use--package's :vc keyword?
> >> 
> >> Built-in packages are not supported by package-vc right now, as
> >> emacs.git is not a emacs package the way ELPA intends it.  There is also
> >> the annoyance that without custom code (which would be doable if we had
> >> to) we would have a separate checkout of emacs.git for every built-in
> >> package that one wishes to clone that way.  This would be a lot easier
> >> if Git would support subtree or single-file checkouts...
> >
> > So we should convert this bug into a feature-request, and meanwhile
> > document this restriction in the use-package manual?
> 
> If anything, we should document this in (emacs) Fetching Package
> Sources, but one can mention that in the use-package manual as well.

Thanks, done on the emacs-30 branch, and closing the bug.

Subject: 31.0.50; use-package cannot override a built in package
From: "Mark A. Hershberger" <[email-masked]>
To: [email-masked]
Date: Fri, 03 Jan 2025 17:29:51 -0500
List-Id: <debbugs-submit.debbugs.gnu.org>

The following command sequence does not check out transient into
~/.emacs.d/elpa/transient while a similar sequence for magit checks out
magit:

    $ rm -rf ~/.emacs.d/
    $ echo '(use-package transient
           :vc (:url "https://github.com/magit/transient") :ensure t)' > .emacs
    $ emacs

Since the bundled transient cannot be used with forge from git, I ended
up installing transient using package-install.

I looked over help for use-package, but I cannot see a way to force it
to use the version specified in :vc for the package instead of the
bundled version.

Thanks,

Mark.